﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	#if B4J
		Private fx As JFX	
	#end if
	Private Button1 As B4XView
	Private TextField1 As B4XView
	Private txtNominativo As B4XView
	'Private txtDataNascita As DatePicker
	Private txtCF As B4XView
	Private txtIca As B4XView
	Private txtEcofin As B4XView
	
	Dim par01 As String
	Dim pageIntestazione As String
	Dim pagePie As String
	Dim azienda As String
	Dim indirizzo As String
	Dim partitaiva As String

	Private lblCF As B4XView
	Private lblData As B4XView
	Private lblDeviceType As B4XView
	Private lblDevIMEI As B4XView
	Private lblDevname As B4XView
	Private lblDevSN As B4XView
	Private lblNominativo As B4XView
	Private txtDevice1 As B4XView
	Private txtdevice2 As B4XView
	Private txtDevice3 As B4XView
	Private txtDevice4 As B4XView
	Private txtDevIMEI1 As B4XView
	Private txtDevIMEI2 As B4XView
	Private txtDevIMEI3 As B4XView
	Private txtDevIMEI4 As B4XView
	Private txtDevSN1 As B4XView
	Private txtDevSN2 As B4XView
	Private txtDevSN3 As B4XView
	Private txtDevSN4 As B4XView

	Private txtRadio As B4XView
	Private txtdevType4 As B4XComboBox
	Private txtdevType3 As B4XComboBox
	Private txtdevType2 As B4XComboBox
	Private txtdevType1 As B4XComboBox
	Private txtDataNascita As DatePicker
	
	Dim nextHeight As Double
	
	'Private ChoiceBox1 As B4XComboBox
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
	xui.SetDataFolder("B4Xpdf")
	'copy images from assets folder to default folder
	File.Copy(File.DirAssets,"image.png",xui.DefaultFolder,"image.png")
	
	File.Copy(File.DirAssets,"IcaIntestazione.png",xui.DefaultFolder,"IcaIntestazione.png")
	File.Copy(File.DirAssets,"EcofinIntestazione.png",xui.DefaultFolder,"EcofinIntestazione.png")
	File.Copy(File.DirAssets,"EcofinPie.png",xui.DefaultFolder,"EcofinPie.png")

End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	nextHeight = 0
	Dim l As List
	
	l.initialize
	l.AddAll(Array As String("","Smartphone", "Tablet", "iPad", "Apple Pencil"))
	
	txtdevType1.SetItems(l)
	txtdevType2.SetItems(l)
	txtdevType3.SetItems(l)
	txtdevType4.SetItems(l)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.



private Sub savePDF(apdf As cPDF,afile As String,acompress As Int)
	Dim folder As String
	#if B4J
		folder=xui.DefaultFolder
	#End If
	#if B4A
		folder=Starter.fFileProvider.SharedFolder	
	#End If
	#if B4I
		'......
	#End If
	apdf.saveToFile(folder,afile,acompress)
End Sub

private Sub openPDF(afile As String)
	#if B4J
		fx.ShowExternalDocument(File.GetUri(xui.DefaultFolder,afile))
	#end if
	#if B4A
		Dim in As Intent
		in.Initialize(in.ACTION_VIEW, "")
		Starter.ffileProvider.SetFileUriAsIntentData(in, afile)
		in.SetComponent("android/com.android.internal.app.ResolverActivity")
		in.SetType("application/pdf")
		StartActivity(in)
	#end if
	#if B4I
	'......
	#End If
End Sub

Private Sub Button1_Click
	Dim companyDet As String
	
	If txtEcofin.Checked Or txtIca.Checked Then
		Dim pdf As cPDF
		InitializePDF(pdf, "spsp", "Multi line text", "B4X,PDF,Cross platform")
		' Set starting position
		If txtEcofin.Checked Then
			companyDet = SetupCompanyDetails("EcofinIntestazione.png", "EcofinPie.png", "ECOFIN s.r.l.", "via San Domenico Savio 34, 31038 Castagnole di Paese (TV)", "03667840262")
		Else If txtIca.Checked Then
			companyDet = SetupCompanyDetails("IcaIntestazione.png", "EcofinPie.png", "ICA SYSTEM s.r.l.", "via San Domenico Savio 34, 31038 Castagnole di Paese (TV)", "01973780263")
	
		End If
		
		nextHeight = nextHeight + MeasureMultilineTextHeight(fx.DefaultFont(20), 100, companyDet)
		Log(nextHeight)
	
		AddImagesToPDF(pdf, pageIntestazione, pagePie)
		Dim docTitle As String = $"${CRLF}${CRLF}${CRLF}${CRLF}${CRLF}${CRLF} ${CRLF}CONTRATTO DI COMODATO D’USO GRATUITO PER UTILIZZO BENI AZIENDALI ${CRLF}${CRLF}${CRLF}"$
		AddDocumentTitleToPDF(pdf, docTitle)
		
		nextHeight = nextHeight + MeasureMultilineTextHeight(fx.DefaultFont(20), 100, docTitle)
		Log(nextHeight)
		AddCompanyDetailsToPDF(pdf, azienda, indirizzo, partitaiva)
		AddNominativeDetailsToPDF(pdf)
    
		SaveAndOpenPDF(pdf, "test.pdf", pdf.CompressAlways)
	
	Else
		xui.MsgboxAsync("Dei Campi NON sono Compilati","ERRORE")
		
	End If

End Sub

Private Sub InitializePDF( pdf As cPDF, author As String, title As String, keywords As String)
	pdf.Initialize("mm")
	pdf.sProperty(pdf.PropertyAuthor, author).sProperty(pdf.PropertyTitle, title).sProperty(pdf.PropertyKeywords, keywords)
	pdf.pageAdd(pdf.pageSizeA4PortraitWidth, pdf.pageSizeA4PortraitHeight)
	pdf.sx(0).sY(287)
	
End Sub

Private Sub SetupCompanyDetails(intestazioneImg As String, pieImg As String, companyName As String, address As String, vatNumber As String)
	pageIntestazione = intestazioneImg
	pagePie = pieImg
	azienda = companyName
	indirizzo = address
	partitaiva = vatNumber
End Sub

Private Sub AddImagesToPDF(pdf As cPDF, intestazioneImg As String, pieImg As String)
	pdf.outImage(xui.DefaultFolder, intestazioneImg, 5, 260, 0, 0)
	pdf.outImage(xui.DefaultFolder, pieImg, 10, 0, 0, 0)
End Sub

Private Sub AddDocumentTitleToPDF(pdf As cPDF, title As String)
	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 14, pdf.colorBlack)
	pdf.outtextflow(10, 200, pdf.AlignCenter, title)
End Sub

Private Sub AddCompanyDetailsToPDF(pdf As cPDF, companyName As String, address As String, vatNumber As String)
	Dim companyDetails As String = $"${CRLF}${CRLF}${companyName} con sede legale in ${address} P.IVA ${vatNumber}, in persona del legale rappresentante pro-tempore – di seguito comodante"$
	pdf.sFont(pdf.fontCourier, pdf.fontNormal, 12, pdf.colorBlack)
	pdf.outtextflow(14, 186, pdf.AlignJusify, companyDetails)
	nextHeight = nextHeight + MeasureMultilineTextHeight(fx.DefaultFont(20), 100, companyDetails)
	Log(nextHeight)
End Sub

Private Sub AddNominativeDetailsToPDF(pdf As cPDF)
	If txtNominativo.Text = "" Then
		xui.MsgboxAsync("Campo Importante Vuoto","ERRORE")
	Else if txtCF.Text = "" Then
		DateTime.DateFormat="dd/MM/YYYY"
		Dim nominativeDetails As String = $"${CRLF}${CRLF}${txtNominativo.Text} (NATO IL ${DateTime.Date(txtDataNascita.DateTicks)})${CRLF}${CRLF} – di seguito denominato comodatario/collaboratore"$
	'Dim nominativeDetails As String = $"${CRLF}${CRLF}${txtNominativo.Text} (NATO IL ${DateTime.Date(DateUtils.TicksToString(txtDataNascita.DateTicks))})${CRLF}${CRLF} – di seguito denominato comodatario/collaboratore"$
		pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
		pdf.outtextflow(14, 184, pdf.AlignCenter, nominativeDetails)
	Else
		DateTime.DateFormat="dd/MM/YYYY"
	'	Dim nominativeDetails As String = $"${CRLF}${CRLF}${txtNominativo.Text} (NATO IL ${DateTime.Date(DateUtils.TicksToString(txtDataNascita.DateTicks))}), CODICE FISCALE: ${txtCF.Text}${CRLF}${CRLF} – di seguito denominato comodatario/collaboratore"$
		Dim nominativeDetails As String = $"${CRLF}${CRLF}${txtNominativo.Text} (NATO IL ${DateTime.Date(txtDataNascita.DateTicks)}), CODICE FISCALE: ${txtCF.Text}${CRLF}${CRLF} – di seguito denominato comodatario/collaboratore"$
		pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
		pdf.outtextflow(14, 184, pdf.AlignCenter, nominativeDetails)
		
	End If
	
	Dim subtitle As String = $"${CRLF}${CRLF}${CRLF}Tra le parti si stipula quanto segue"$
	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignCenter, subtitle)
	
	Dim height As Double = MeasureMultilineTextHeight(fx.DefaultFont(20), 100, subtitle)
	nextHeight = nextHeight + height
	Log(nextHeight)
	
'	Log(pdf.gTextSize(subtitle))
	Dim art1tit As String = $"${CRLF}${CRLF}Art. 1 - Oggetto"$
	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art1tit)
	
	Dim art1body As String = $"${CRLF}${CRLF}${azienda} per consentire al comodatario di espletare al meglio la propria attività lavorativa a titolo di comodato d’uso gratuito, consegna temporaneamente i beni di sua esclusiva proprietà e in perfetto stato di funzionamento, sotto dettagliati:"$
	pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art1body)
	
	Dim device01 As String
	Dim device02 As String
	Dim device03 As String
	Dim device04 As String
	
	If txtdevType1.SelectedIndex <> 0 Then
		Dim device01 As String = $"${CRLF}N1. ${txtdevType1.GetItem(txtdevType1.SelectedIndex)} (${txtDevice1.Text}, S/N: ${txtDevSN1.Text}, IMEI: ${txtDevIMEI1.Text})"$
		pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
		pdf.outtextflow(14, 184, pdf.AlignLeft, device01)
	End If

	If txtdevType2.SelectedIndex <> 0 Then
		Dim device02 As String = $"${CRLF}N1. ${txtdevType2.GetItem(txtdevType2.SelectedIndex)} (${txtdevice2.Text}, S/N: ${txtDevSN2.Text}, IMEI: ${txtDevIMEI2.Text})"$
		pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
		pdf.outtextflow(14, 200, pdf.AlignLeft, device02)
	End If

	If txtdevType3.SelectedIndex <> 0 Then
		Dim device03 As String = $"${CRLF}N1. ${txtdevType3.GetItem(txtdevType3.SelectedIndex)} (${txtDevice3.Text}, S/N: ${txtDevSN3.Text}, IMEI: ${txtDevIMEI3.Text})"$
		pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
		pdf.outtextflow(14, 216, pdf.AlignLeft, device03)
	End If

	If txtdevType4.SelectedIndex <> 0 Then
		Dim device04 As String = $"${CRLF}N1. ${txtdevType4.GetItem(txtdevType4.SelectedIndex)} (${txtDevice4.Text}, S/N: ${txtDevSN4.Text}, IMEI: ${txtDevIMEI4.Text})"$
		pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
		pdf.outtextflow(14, 232, pdf.AlignLeft, device04)
	End If
	Dim art02Title As String = $"${CRLF}${CRLF}Art. 2 – Obblighi del comodante${CRLF}"$
	Dim art02Body As String = $"a) consegnare i beni perfettamente funzionanti;
b) garantire il pacifico godimento del bene da parte del comodatario per l’intera durata del rapporto di lavoro."$

	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art02Title)
	
	pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art02Body)
	
	Dim art03Title As String = $"${CRLF}${CRLF}Art. 3 – Obblighi del comodatario${CRLF}"$
	Dim art03Body As String = $"a) prendere in consegna i beni, utilizzarli e conservarli con la diligenza del buon padre di famiglia;
b) utilizzare i beni dati in comodato solo ed esclusivamente per espletare l’attività lavorativa; 
c) restituire i beni alla scadenza del rapporto di lavoro e/o quando vengono richiesti dal comodante nel medesimo stato in cui li ha ricevuti, salvo normale usura.}
"$

	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art03Title)
	
	pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft,art03Body )

	Dim height As Double = MeasureMultilineTextHeight(fx.DefaultFont(20), 100, art03Title & art03Body)
	Log(height)
	Dim heightInMM As Double = MeasureMultilineTextHeightMM(fx.DefaultFont(20), 100, art03Title & art03Body)
	Log("Altezza in millimetri: " & heightInMM)
	If 	nextHeight > 841.89 Then
		
	
	'add a page
	pdf.pageAdd(pdf.pageSizeA4PortraitWidth,pdf.pageSizeA4PortraitHeight)
	pdf.sx(0).sY(287)
	AddImagesToPDF(pdf, pageIntestazione, pagePie)
	Dim companyDet As String
	
	If txtEcofin.Checked Or txtIca.Checked Then
		' Set starting position
		If txtEcofin.Checked Then
			companyDet = SetupCompanyDetails("EcofinIntestazione.png", "EcofinPie.png", "ECOFIN s.r.l.", "via San Domenico Savio 34, 31038 Castagnole di Paese (TV)", "03667840262")
		Else If txtIca.Checked Then
			companyDet = SetupCompanyDetails("IcaIntestazione.png", "EcofinPie.png", "ICA SYSTEM s.r.l.", "via San Domenico Savio 34, 31038 Castagnole di Paese (TV)", "01973780263")
	
		End If
	
	
	End If
	
	End If
	
	Dim art04Tit As String = $"${CRLF}${CRLF} ${CRLF}${CRLF}${CRLF}${CRLF}${CRLF}${CRLF}${CRLF}Art. 4 – Responsabilità del comodatario${CRLF}"$
	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art04Tit)
	
	Dim art04 As String = $"${CRLF}${CRLF}${CRLF}${CRLF}}Il comodatario è responsabile della custodia dei beni e dei danni provocati a terzi per uso improprio.
Il comodatario non potrà in alcun modo apportare formattazioni, variazioni, alterazioni o qualsiasi altro tipo di modifica ai beni. Nelle ipotesi di danneggiamento o distruzione dei beni, l'utilizzatore dovrà corrispondere ad Ica System s.r.l. i costi relativi alla riparazione o al riacquisto del bene medesimo, oltre al risarcimento del danno.
L’affidamento del cellulare aziendale dovrà avere una durata minima di 2 anni, salvo inoperatività causa difetto di fabbrica. Per eventuali richieste di sostituzione anticipata prima dei 24 mesi dalla data di consegna verrà addebitata una franchigia (salvo vengano riconosciuti difetti di fabbrica):
- 70% del valore del telefono entro i primi 12 mesi dalla consegna del dispositivo;
- 50% dopo i primi 12 mesi dalla consegna del dispositivo;
Le riparazioni straordinarie e tutte quelle che si dovessero rendere necessarie a causa di un uso non corretto del bene sono a carico dell’utilizzatore.
${CRLF}${CRLF}
"$


	pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, art04)

	Dim height As Double = MeasureMultilineTextHeight(fx.DefaultFont(20), 100, art04Tit & art04)
	Log(height)
	Dim heightInMM As Double = MeasureMultilineTextHeightMM(fx.DefaultFont(20), 100, art03Title & art03Body)
	Log("Altezza in millimetri: " & heightInMM)
	pdf.sFont(pdf.fontHelvetica, pdf.fontBold, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, $"Art. 5 – Consegna del bene${CRLF}"$)
	
	pdf.sFont(pdf.fontHelvetica, pdf.fontNormal, 12, pdf.colorBlack)
	pdf.outtextflow(14, 184, pdf.AlignLeft, $"La consegna all'utilizzatore avverrà contestualmente alla firma del presente documento
${CRLF}${CRLF}
"$)
	
End Sub

Private Sub SaveAndOpenPDF(pdf As cPDF, fileName As String, compress As Int)
	savePDF(pdf, fileName, compress)
	openPDF(fileName)
End Sub


Private Sub AddParagraph(pdf As cPDF, x As Float, y As Float, width As Float, text As String, font As String, fontSize As Double, color As Int, align As Int, topSpacing As Float, bottomSpacing As Float) As Float
	' Convert fontSize to Double if it isn't already
	Dim fontSizeDouble As Double = fontSize

	' Convert color from Int to an array of Double representing RGB
	Dim colorArray(3) As Double
	colorArray(0) = Bit.And(Bit.ShiftRight(color, 16), 0xFF) / 255.0 ' Red
	colorArray(1) = Bit.And(Bit.ShiftRight(color, 8), 0xFF) / 255.0 ' Green
	colorArray(2) = Bit.And(color, 0xFF) / 255.0 ' Blue

	' Set font and color
	pdf.sFont(font, pdf.fontNormal, fontSizeDouble, colorArray)

	' Move down for top spacing
	y = y - topSpacing

	' Draw text
	pdf.outtextflow(x, width, align, text)

	' Adjust y for bottom spacing
	y = y - bottomSpacing

	' Return updated y position
	Return y
End Sub



Sub MeasureMultilineTextHeight (Font As Font, Width As Double, Text As String) As Double
	Dim jo As JavaObject = Me
	' Calcola l'altezza in punti
	Dim heightInPoints As Double = jo.RunMethod("MeasureMultilineTextHeight", Array(Font, Text, Width))
	' Converte l'altezza da punti a millimetri
	Dim heightInMM As Double = heightInPoints * 0.3528
	Return heightInMM
End Sub

#if Java
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import javafx.scene.text.Font;
import javafx.scene.text.TextBoundsType;
public static double MeasureMultilineTextHeight(Font f, String text, double width) throws Exception {
  Method m = Class.forName("com.sun.javafx.scene.control.skin.Utils").getDeclaredMethod("computeTextHeight",
  Font.class, String.class, double.class, TextBoundsType.class);
  m.setAccessible(true);
  return (Double)m.invoke(null, f, text, width, TextBoundsType.LOGICAL_VERTICAL_CENTER);
  }
#End If

Sub MeasureMultilineTextHeightMM (Font As Font, Width As Double, Text As String) As Double
	Dim jo As JavaObject = Me
	' Calcola l'altezza in punti
	Dim heightInPoints As Double = jo.RunMethod("MeasureMultilineTextHeight", Array(Font, Text, Width))
	' Converte l'altezza da punti a millimetri
	Dim heightInMM As Double = heightInPoints * 0.3528
	Return heightInMM
End Sub